; TIP1155.LSP: IMTEXT.LSP   Import Text via Dialog Box
;                            (c)1995, Frances Gainer Davey

;;Requires IMTEXT.DCL.  
;;Be sure the text style you specify has a given height.

(defun C:IT (/ POP DIA_MODE DISCOL VAR TX CHTX TXTSTY 
    ROT COLLEN OLDTXT TEXTSZ FH1 FH TXT PT1 PT2 UNDSC 
  UPPCS LOWCS SETCL ITSTY)
  (setq OLDECHO (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (command ".undo" "m")(princ)
  (setq ROT "0")
  (setq TXTSTY (getvar "TEXTSTYLE"))
  (setq DISCOL "1")
  (if (< (setq POP (load_dialog "imtext.dcl")) 0) (exit))
  (setq DIA_MODE 4)
  (while (< 2 DIA_MODE)
    (if (not (NEW_DIALOG "imtext" POP)) (exit))
    (defset)
    (set_tile "rot" ROT)
    (set_tile "txtht" TXTSTY)
    (if FH (set_tile "fname" FH))
    (set_tile "coldis" DISCOL)
    (action_tile "fname" "(setq FH $VALUE)")
    (action_tile "coldis" "(setq DISCOL $VALUE)")
    (action_tile "txtht" "(it:sty)")
    (action_tile "rot" "(setq ROT $VALUE)")
    (action_tile "collin" "(setq COLLEN $VALUE)")
    (action_tile "unsc" "(setq UNDSC (atoi $VALUE))")
    (action_tile "upc" "(setq UPPCS (atoi $VALUE))")
    (action_tile "lwc" "(setq LOWCS (atoi $VALUE))")
    (action_tile "setcol" "(setq SETCL (atoi $VALUE))")
    (action_tile "selfil" "(it:selfil)")
    (action_tile "edfil" "(it:edfil)(set_tile \"fname\" FH)(done_dialog 4)")
    (action_tile "pickpt" "(done_dialog 3)")
    (action_tile "accept" "(if (not PT1) (it:err) (progn
  (setq VAR 1)(it:set)(done_dialog)))")
  (action_tile "cancel" "(done_dialog)(setq VAR nil)")
  (setq dia_mode (start_dialog))
  (cond ((= DIA_MODE 4) (initget 1)
      (progn
      (command "edit" FH) (princ))
    )
  )
  (cond ((= DIA_MODE 3) (initget 1)
    (setq PT1 (getpoint "Pick text insertion point: ")))
  )
)
(unload_dialog pop)
(if VAR (progn (if (= 1 SETCL) (it:cols)(it:txt))))
(setvar "CMDECHO" OLDECHO)
(princ)
)
(defun it:sty ()
   (setq TXTSTY $VALUE)
   (setq ITSTY (tblsearch "style" TXTSTY))
   (if (not ITSTY) (alert "\nStyle not defined"))
   (if (and ITSTY (= (cdr (assoc 40 ITSTY)) 0.0))
      (alert "\nCurrent text style\nmust have set height")
   )
)
(defun it:edfil ()
   (setq FH (getfiled "Edit an Ascii Text File" "" "doc" 1))
)
(defun defset () ;default settings maintained after picking point.
   (if rot (set_tile "rot" ROT))
   (if TXTSTY (set_tile "txtht" TXTSTY))
   (if DISCOL (set_tile "coldis" DISCOL))
   (if COLLEN (set_tile "collin" COLLEN))
   (if (or (not UNDSC) (= 0 UNDSC)) (set_tile "unsc" "0")
      (progn (set_tile "unsc" "1")(setq UNDSC 1)))
   (if (or (not UPPCS) (= 0 UPPCS)) (set_tile "upc" "0")
      (progn (set_tile "upc" "1")(setq UPPCS 1)))
   (if (or (not LOWCS) (= 0 LOWCS)) (set_tile "lwc" "0")
      (progn (set_tile "lwc" "1")(setq LOWCS 1)))
   (if (or (not SETCL) (= 0 SETCL)) (set_tile "setcol" "0")
      (progn (set_tile "setcol" "1")(setq SETCL 1)))
)
(defun it:err ()
   (if (not PT1)
   (set_tile "error" "Please pick an insertion point") (it:set))
)
(defun it:set ()
   (setq VAR 1)
   (setq ROT (get_tile "rot"))
   (setq TXTSTY (get_tile "txtht"))
   (setq DISCOL (get_tile "coldis"))
   (setq DISCOL (* (getvar "dimscale") (atof DISCOL)))
   (setq COLLEN (get_tile "collin"))
   (setq COL_LEN (atoi COLLEN))
   (if (= "1" (get_tile "unsc")) (setq UNDSC 1) (setq UNDSC nil))
   (if (= "1" (get_tile "upc")) (setq UPPCS 1) (setq UPPCS nil))
   (if (= "1" (get_tile "lwc")) (setq LOWCS 1) (setq lOWCS nil))
   (if (= "1" (get_tile "setcol")) (setq SETCL 1) (setq SETCL nil))
)
(defun it:txt ()
   (if FH
      (progn
         (setq FH1 (open fh "r"))
         (setq TXT (read-line FH1))
         (it:format)
         (command ".text" "s" TXTSTY PT1 ROT TXT)
      )
   )
      (progn
         (while TXT
            (setq TXT (read-line FH1))
            (it:format)
            (command ".text" "" TXT)
         )
      )
   (close FH1)
)
;;Places text in column form
(defun it:cols ()
   (if FH
      (progn
         (setq FH1 (open fh "r"))
         (setq TXT (read-line FH1))
         (it:format)
         (command ".text" "s" TXTSTY PT1 ROT TXT)
      )
   )
         (while TXT
            (progn
               (repeat (1- COL_LEN)
                  (setq txt (read-line fh1))
                  (it:format)
                  (command ".text" "" TXT)
               )
               (setq PT1 (list (+ (car PT1) DISCOL) (cadr PT1)))
               (setq TXT (read-line FH1))
               (it:format)
               (command ".text" PT1 ROT TXT)
         )
      )
   (close FH1)
)
(defun it:selfil ()
   (setq FH1 (getfiled "Select Ascii Text File" "" "txt;doc" 4))
   (if FH1 (set_tile "fname" FH1))
   (setq FH (get_tile "fname"))
)
(defun it:format ()
   (if (and TXT (= 1 UNDSC)) (setq TXT (strcat "%%u" TXT)))
   (if (and TXT (= 1 UPPCS)) (setq TXT (strcase TXT)))
   (if (and TXT (= 1 LOWCS)) (setq TXT (strcase TXT 1)))
)
(defun *error* (S)
   (if (not (member S '("console break" "Function cancelled")))
       (princ (strcat "\nError: " S))
   )
   (setvar "cmdecho" oldecho)
       (princ)
)
(princ "\nImptxt loaded.  Start command with IT. ")
(princ); end imtext.lsp
