; TIP1160.LSP: WTRUSS.LSP   Wood Roof Truss   (c)1995, Bill Bratt
;                            $50 BONUS WINNER

(defun *error* (msg)
  (if (/= msg "Function cancelled")
    (princ (strcat "\nAutoLISP Error:  " msg))
    (terpri)
  )
  (setvar "CMDECHO" S_CMD )
  (setvar "BLIPMODE" S_BLIP )
  (setvar "ORTHOMODE" S_ORTH )
  (setvar "OSMODE" S_OSM )
  (command
    "layer" "s" CL ""
    "redraw"
  )
)  ; end of function
(defun start ()
  (graphscr)
  (setq CL (getvar "CLAYER"))
  (setq S_CMD (getvar "CMDECHO"))
  (setq S_BLIP (getvar "BLIPMODE"))
  (setq S_ORTH (getvar "ORTHOMODE"))
  (setq S_OSM (getvar "OSMODE"))
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)     
  (setvar "ORTHOMODE" 1)             ;ortho on
  (setvar "OSMODE" 0)   ; none
  (setq DN (* pi (/ 270.0 180.0)))   ;angle down
  (setq RT (* pi (/ 0.0 180.0)))    ;angle right
  (setq UP (* pi (/ 90.0 180.0)))      ;angle up
  (setq LT (* pi (/ 180.0 180.0)))   ;angle left
)   ;end of function
(defun exit ()
  (setvar "CMDECHO" S_CMD )
  (setvar "BLIPMODE" S_BLIP )
  (setvar "ORTHOMODe" S_ORTH )
  (setvar "OSMODE" S_OSM )
  (command "LAYER" "s" CL "")
)   ; end of function
; global variables
(setq TCHDS    5.5)   ; top chord size 
(setq BCHDS    3.5)   ; bottom chord size 
(setq WEBS     3.5)   ; web size 
(setq RISE     4.0)   ; rise
(setq LOH     24.0)   ; left overhang
(setq ROH     24.0)   ; right overhang
(setq FASTHK   1.5)   ; fascia thickness

(defun C:WTRUSS ( / LP RP TSPAN HSPAN SD1 SD2 SD3 SDA1 SDA2 
    ANG HYP LOHD ROHD LPD RPD PT1 PT2 PT3 PT4 PT5 PT6 PT7 PT8 
    PT1_3  PT2_3 LPU RPU HYPH MP1 MP2 MP3 MP4 MP5 BCHDH CL1 
    CL2 CL3 CL4 CL5 CL6 ANG_UR ANG_UL CLTC CLTCH CLBC CLBCH
  WEBH MM1 MM2 MM3 OF1L OF2L OF1U OF2 W1L W2L W3L W4L W5L)
  (start)
  ;INPUT using global values for defaults
  (setq LP (getpoint "\nPick working point at left side of truss:  "))
  (setq RP (getpoint LP "\nPick working point at right side of truss:  "))
  (setq number tchds)
  (G_DIST "\nPick or enter the width of the top chord: ")
  (setq TCHDS NUMBER)
  (setq NUMBER BCHDS)
  (G_DIST "\nPick or enter the width of the bottom chord: ")
  (setq BCHDS NUMBER)
  (setq NUMBER WEBS)
  (G_DIST "\nPick or enter the width of the web members: ")
  (setq WEBS NUMBER)
  (setq NUMBER RISE)
  (G_DIST "\nPick or enter the slope diagram rise: ")
  (setq RISE NUMBER)
  (setq NUMBER LOH)
  (G_DIST "\nPick or enter the left overhang distance: ")
  (setq LOH NUMBER)
  (setq NUMBER ROH)
  (G_DIST "\nPick or enter the right overhang distance: ")
  (setq ROH NUMBER)
  (setq NUMBER FASTHK)
  (G_DIST "\nPick or enter the fascia thickness: ")
  (setq FASTHK NUMBER)
  ;calcualtion of points
  (setq TSPAN (distance LP RP))
  (setq HSPAN (/ TSPAN 2.0))
  (setq SD1 (list 0 0))
  (setq SD2 (polar SD1 UP RISE))
  (setq SD3 (polar SD2 RT 12.0))
  (setq SDA1 (angle SD2 SD1))
  (setq SDA2 (angle SD1 SD3))
  (setq ANG (abs (- SDA2 SDA1)))
  (setq HYP (abs (/ TCHDS (sin ANG))))
  (setq LOHD (- LOH FASTHK))
  (setq rohd (- ROH FASTHK))
  (setq LPD (polar LP DN (ris LOHD)))
  (setq RPD (polar RP DN (ris ROHD)))
  (setq PT1 (polar LPD LT LOHD))
  (setq PT5 (polar RPD RT ROHD))
  (setq PT2 (polar PT1 UP HYP))
  (setq PT4 (polar PT5 UP HYP))
  (setq PT2_3 (polar PT2 UP (ris (+ HSPAN LOHD))))
  (setq PT3 (polar PT2_3 RT (+ HSPAN LOHD)))
  (setq PT1_3 (polar PT1 RT (+ LOHD HSPAN)))
  (setq PT6 (polar PT1_3 UP (ris (+ LOHD HSPAN))))
  (setq LPU (polar LP UP BCHDS))
  (setq RPU (polar RP UP BCHDS))
  (setq PT7 (inters LPU RPU PT1 PT6 nil))
  (setq PT8 (inters LPU RPU PT5 PT6 nil))
  ; draw lines of truss - top & bottom chords
  (command "line" LP RP "")
  (command "line" PT7 PT8 "")
  (command "line" PT1 PT2 PT3 PT4 PT5 PT6 PT1 "")
  ;calcualtion of points for webs
  (setq HYPH (/ HYP 2.0))
  (setq MP1 (poLAR PT1 UP HYPH))
  (setq MP5 (polar PT5 UP HYPH))
  (setq MP3 (polar PT6 UP HYPH))
  (setq BCHDH (/ BCHDS 2.0))
  (setq MP2 (polar LP UP BCHDH))
  (setq MP4 (polar RP UP BCHDH))
  (setq CL1 (inters MP1 MP3 MP2 MP4 nil))
  (setq CL4 (inters MP5 MP3 MP2 MP4 nil))
  (setq ANG_UR (angle MP1 MP3))
  (setq ANG_UL (angle MP5 MP3))
  (setq CLTC (distance CL1 Mp3))
  (setq CLTCH (/ CLTC 2.0))
  (setq CLBC (distance CL1 CL4))
  (setq CLBCH (/ CLBC 3.0))
  (setq CL2 (polar CL1 ANG_UR CLTCh))
  (setq CL3 (polar CL4 ANG_UL CLTCh))
  (setq CL6 (polar CL1 RT CLBCH))
  (setq CL5 (polar CL4 LT CLBCH))
  (setq WEBH (/ WEBS 2.0))
  (setq MM1 (polar PT6 DN (- (* (/ HSPAN 12.0) RISE) (* 2 BCHDS))))
  (setq MM2 (polar MM1 LT CLBCH))
  (setq MM3 (polar MM2 UP 2.0))
  (setq OF1L (polar MP3 (- (angle CL6 MP3) (/ pi 2.0)) WEBH))
  (setq OF2L (polar CL6 (- (angle CL6 MP3) (/ pi 2.0)) WEBH))
  (setq OF1U (polar MP3 (+ (angle CL6 MP3) (/ pi 2.0)) WEBH))
  (setq OF2U (polar CL6 (+ (angle CL6 MP3) (/ pi 2.0)) WEBH))
  (setq W1L (inters PT3 MM1 OF1L OF2L nil))
  (setq W2L (inters PT7 PT8 OF1L OF2L nil))
  (setq W3L (inters PT1 PT6 OF1U OF2U nil))
  (setq W4L (inters PT7 PT8 OF1U OF2U nil))
  (if (> (cadr W1L) (cadr PT6))
    (setq W1L (inters PT1 PT6 OF1L OF2L nil))
  )
  ; draw centerlines of all members  
  ;  (command "line" CL1 MP3 CL4 CL1 "")
  ;  (command "line" CL2 CL6 MP3 CL5 CL3 "")
  ; draw web members
  (command "line" W1L W2L "")
  (command "line" W3L W4L "")
  (command "line" W1L PT6 "")
  (setq W5L W4L)
  (setq OF1L (polar CL2 (- (angle CL6 CL2) (/ pi 2.0)) WEBH))
  (setq OF2L (polar CL6 (- (angle CL6 CL2) (/ pi 2.0)) WEBH))
  (setq OF1U (polar CL2 (+ (angle CL6 CL2) (/ pi 2.0)) WEBH))
  (setq OF2U (polar CL6 (+ (angle CL6 CL2) (/ pi 2.0)) WEBH))
  (setq W1L (inters PT1 PT6 OF1l oF2L NIL))
  (setq W2L (inters W3L W4L OF1l of2l nil))
  (setq W3L (inters PT1 PT6 OF1u of2u nil))
  (setq W4L (inters PT7 PT8 OF1u of2u nil))
  (command "line" W1L W2L "")
  (command "line" W3L W4L "")
  (command ".mirror" "c" MM1 MM3 "" PT3 PT6 "n" "" "")
  (EXIT)
  (princ)
)
(defun ris ( HOR / )
  (setq VDIST (* (/ HOR 12.0) RISE))
)
(defun g_dist (_TXT / A)
  (if NUMBER
    (setq A (getdist (strcat _TXT " <"
    (rtos NUMBER 4 4 )">: ")))
    (setq A (getdist (strcat _TXT": ")))
  )
  (if A (setq NUMBER A) )
)
(princ) ;end wtruss.lsp

